<?php
/* Created by Yannik Eichel - yannik-eichel@web.de */ 
class SynoFileHostingSimplyPremium {
	private $Url;
	private $Username;
	private $Password;
	private $HostInfo;
	private $SP_COOKIE = '/tmp/simplypremium.cookie';

	public function __construct($Url, $Username, $Password, $HostInfo) {
		$this->Url = $Url;
		$this->Username = $Username;
		$this->Password = $Password;
		$this->HostInfo = $HostInfo;
	}
	
	//This function verifies and returns account type.
	public function Verify($ClearCookie)
	{
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($curl, CURLOPT_USERAGENT, DOWNLOAD_STATION_USER_AGENT);
		curl_setopt($curl, CURLOPT_COOKIEFILE, $this->SP_COOKIE);
		curl_setopt($curl, CURLOPT_COOKIEJAR, $this->SP_COOKIE);
		curl_setopt($curl, CURLOPT_POST, false);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($curl, CURLOPT_URL, 'https://www.simply-premium.com/api/v2/user.php?format=json');
		$res = curl_exec($curl);
		$user = json_decode($res, true);
		if($user["result"]["vip"] == 0){//Login wahscheinlich noch nicht vorhanden
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);//einloggen
			curl_setopt($curl, CURLOPT_USERAGENT, DOWNLOAD_STATION_USER_AGENT);
			curl_setopt($curl, CURLOPT_COOKIEFILE, $this->SP_COOKIE);
			curl_setopt($curl, CURLOPT_COOKIEJAR, $this->SP_COOKIE);
			curl_setopt($curl, CURLOPT_POST, TRUE);
			curl_setopt($curl, CURLOPT_POSTFIELDS, "login_name=".$this->Username."&login_pass=".$this->Password."&format=json");
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			curl_setopt($curl, CURLOPT_URL, 'https://www.simply-premium.com/api/v2/login.php');
			$res = curl_exec($curl);
			$login = json_decode($res, true);
			if($login["result"]["valid"] == 1){//Login erfolgreich
				curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);//API erneut abfragen
				curl_setopt($curl, CURLOPT_USERAGENT, DOWNLOAD_STATION_USER_AGENT);
				curl_setopt($curl, CURLOPT_COOKIEFILE, $this->SP_COOKIE);
				curl_setopt($curl, CURLOPT_COOKIEJAR, $this->SP_COOKIE);
				curl_setopt($curl, CURLOPT_POST, false);
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
				curl_setopt($curl, CURLOPT_URL, 'https://www.simply-premium.com/api/v2/user.php?format=json');
				$res = curl_exec($curl);
				$user = json_decode($res, true);
			}else{//nicht erfolgreich
				$ret = LOGIN_FAIL;
				return $ret;
			}
		}
		if($user["result"]["vip"] == 0){
			$ret = ERR_REQUIRED_PREMIUM;
		}else{
			$ret = USER_IS_PREMIUM;
		}
		curl_close($curl);
		if ($ClearCookie && file_exists($this->SP_COOKIE)) {
			unlink($this->SP_COOKIE);
		}
		return $ret;
	}
	
	//This function returns download url.
	public function GetDownloadInfo() {
		if($this->Verify(false) == USER_IS_PREMIUM){
			$curl = curl_init();
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($curl, CURLOPT_USERAGENT, DOWNLOAD_STATION_USER_AGENT);
			curl_setopt($curl, CURLOPT_COOKIEFILE, $this->SP_COOKIE);
			curl_setopt($curl, CURLOPT_COOKIEJAR, $this->SP_COOKIE);
			curl_setopt($curl, CURLOPT_POST, false);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			curl_setopt($curl, CURLOPT_URL, 'https://www.simply-premium.com/prem.php?info=1&link='.$this->Url);
			$res = curl_exec($curl);
			curl_close($curl);
			if(strpos($res, "<code>0</code>") !== false){
				$DownloadInfo = array();
				$DownloadInfo[DOWNLOAD_URL] = trim($this->GetBetween($res,"<download>","</download>"));
			}else{
				$DownloadInfo[DOWNLOAD_ERROR] = ERR_FILE_NO_EXIST;
			}
			return $DownloadInfo;
		}else{
			return false;
		}
	}
	function GetBetween($content,$start,$end){
		$r = explode($start, $content);
		if (isset($r[1])){
			$r = explode($end, $r[1]);
			return $r[0];
		}
		return '';
	}
}